/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jdcbdemo;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author bar
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Connection con = null;
        try {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            con = DriverManager.getConnection("jdbc:derby://localhost:1527/graves", "test", "test");

            con.setAutoCommit(false);

            PreparedStatement insert = con.prepareStatement("insert into APP.GRAVE values(?,?,?)");
            PreparedStatement select = con.prepareStatement("select * from APP.Grave");
            PreparedStatement update = con.prepareStatement("update APP.GRAVE set secondperson=? where id=?");
            PreparedStatement delete = con.prepareStatement("delete from APP.Grave where secondperson=?");
            PreparedStatement deleteAll = con.prepareStatement("delete from APP.Grave");
            insert.setInt(1,1);
            System.out.println("Vkladani:");
            insert.setString(2,"Prvni Obet");
            insert.setString(3, "");

            insert.executeUpdate();

            insert.setInt(1, 2);
            insert.setString(2, "Druha Obet");
            insert.setString(3,"Treti Obet");

            insert.execute();
            con.commit();
            listDB(select);


            update.setInt(2,1);
            update.setString(1,"Posledni Obet");

            update.executeUpdate();
            con.commit();
            System.out.println("Update:");
            listDB(select);

            delete.setString(1,"Treti Obet");
            delete.executeUpdate();
            con.rollback();
            System.out.println("Smazani zaznamu:");
            listDB(select);

            deleteAll.execute();
            con.commit();
            System.out.println("Vymazani dat:");
            listDB(select);
            con.commit();


            
        } catch (SQLException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            if(con != null){
                try {
                    con.close();
                } catch (SQLException ex) {
                    Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }

    private static void listDB(PreparedStatement select) throws SQLException {
        ResultSet results = select.executeQuery();
        while (results.next()) {
            int id = results.getInt("id");
            String firstPerson = results.getString("firstperson");
            String secondPerson = results.getString("secondperson");
            Grave grave = new Grave(id, firstPerson, secondPerson);
            System.out.println(grave);
        }
    }

}
